/* -*- c++ -*- */
/*
 * Copyright 2014 <+YOU OR YOUR COMPANY+>.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#ifndef INCLUDED_MYMOD_SWITCH_CONST_IMPL_H
#define INCLUDED_MYMOD_SWITCH_CONST_IMPL_H

#include <mymod/switch_const.h>
#include <boost/math/distributions.hpp>
#include <boost/accumulators/accumulators.hpp>
#include <boost/accumulators/statistics/stats.hpp>
#include <boost/accumulators/statistics/mean.hpp>
#include <boost/accumulators/statistics/variance.hpp>
#include <boost/accumulators/statistics/kurtosis.hpp>
#include <boost/accumulators/statistics/skewness.hpp>

namespace ba = boost::accumulators;

namespace gr {
  namespace mymod {

    class switch_const_impl : public switch_const
    {
     private:
      std::vector<digital::constellation_sptr> d_constel;
      ba::accumulator_set< double, ba::stats<ba::tag::mean,
                                             ba::tag::variance,
                                             ba::tag::kurtosis,
                                             ba::tag::skewness> > d_acc_ph;

      ba::accumulator_set< double, ba::stats<ba::tag::mean,
                                             ba::tag::variance,
                                             ba::tag::kurtosis,
                                             ba::tag::skewness> > d_acc_fq;

      int d_count;
      int d_index;
      bool d_switch_ok;

     public:
      switch_const_impl(const std::vector<digital::constellation_sptr> &constell);
      ~switch_const_impl();

      void trigger(pmt::pmt_t msg);

      int general_work(int noutput_items,
                       gr_vector_int &ninput_items,
                       gr_vector_const_void_star &input_items,
                       gr_vector_void_star &output_items);
    };

  } // namespace mymod
} // namespace gr

#endif /* INCLUDED_MYMOD_SWITCH_CONST_IMPL_H */
