#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Copyright 2014 <+YOU OR YOUR COMPANY+>.
#
# This is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
#

import numpy
from gnuradio import gr
import copy

class fir_filter(gr.decim_block):
    """
    docstring for block fir_filter
    """
    def __init__(self, decim, taps):
        gr.decim_block.__init__(self,
                                name="fir_filter",
                                in_sig=[numpy.float32],
                                out_sig=[numpy.float32],
                                decim=decim)
        self.taps = list(taps)
        self.set_history(len(self.taps))

    def work(self, input_items, output_items):
        in0 = input_items[0]
        out = output_items[0]
        noutput_items = len(output_items[0])

        # Very slow
        n = 0
        for i in xrange(noutput_items):
            out[i] = 0
            for j in xrange(len(self.taps)):
                out[i] += in0[n+j]*self.taps[j]
                n += self.decimation()`

        #out[:] = numpy.convolve(in0[0:noutput_items+self.history()],
        #                        self.taps, mode='valid')

        return noutput_items
